; Currency Converter 1.1 by refuge & Hjorten
; Type /currconv to bring up the dialog.

dialog CurrConv {
  title "Currency Converter 1.1"
  size -1 -1 191 111
  option dbu
  edit "", 1, 21 1 55 10
  list 2, 1 18 94 69, sort size vsbar
  list 3, 95 18 94 69, sort size vsbar
  edit "", 4, 1 87 188 10, read autohs
  button "Close", 5, 2 98 37 12, ok
  button "Copy", 6, 39 98 37 12
  button "Convert", 7, 76 98 37 12
  text "Amount", 8, 1 2 19 8
  text "of this type of currency", 9, 1 11 57 7
  text "into this type of currency.", 10, 95 11 63 7
  text "Currency Converter 1.1 by refuge && Hjorten.", 11, 115 97 74 14, center
  check "Popup menu", 12, 78 2 43 7
}

alias CurrConv { dialog -mrv CurrConv CurrConv }
alias CurrConvData { return $chr(34) $+ $scriptdircurr_data.txt $+ $chr(34) }
alias CurrConvTmp { return $chr(34) $+ $scriptdircurr_temp.txt $+ $chr(34) }
alias CurrConvStrip { var %i = $regsub(< $+ $1- $+ <>,/<[^>]*>/g,$chr(32),%out) | return %out }
alias CurrConvSet { .remove $CurrConvTmp | sockopen xe 216.220.38.20 80 | set %xe.amount $did($dname,1).text | set %xe.from $gettok($did($dname,2).seltext,1,32) | set %xe.to $gettok($did($dname,3).seltext,1,32) }
alias CurrConvPut {
  did -e CurrConv 1,2,3,5,6,7
  if (%xe.from !isin $read($CurrConvTmp,1)) || (%xe.to !isin $read($CurrConvTmp,2)) {
    did -ra CurrConv 4 Couldn't gather information for that currency, please try again later.
  }
  elseif (%xe.from isin $read($CurrConvTmp,1)) && (%xe.to isin $read($CurrConvTmp,2)) {
    did -ra CurrConv 4 $gettok($read($CurrConvTmp,1),1-2,32) is $gettok($read($CurrConvTmp,2),1-2,32)
  }
}

on *:LOAD: { echo -ta Currency Converter by refuge & Hjorten has been loaded, type /currconv to bring up the dialog. }
on *:UNLOAD: { echo -ta Currency Converter by refuge & Hjorten has been unloaded | unset %xe.* | unset %xemenu | .remove $CurrConvTmp }


on *:DIALOG:CurrConv:INIT:*: {
  if (!$isfile($CurrConvData)) {
    echo -a ** Cannot find the currency database, please re-download the script.
    echo -a ** Consult the readme for further information.
    dialog -x $dname $dname
  }
  else {
    loadbuf -o $dname 2 $CurrConvData
    loadbuf -o $dname 3 $CurrConvData
    did -b $dname 7
    if (%xemenu == channel) { did -c $dname 12 }
  }
}

on *:DIALOG:CurrConv:SCLICK:7: {
  if ($did($dname,2).sel == $null) || ($did($dname,3).sel == $null) {
    did -ra $dname 4 Select currencies to convert.
  }
  else {
    if ($remove($replace($did($dname,1),$chr(44),$chr(46)),$chr(46)) isnum) {
      did -b $dname 1,2,3,5,6,7
      did -ra $dname 4 Gathering information, please wait.
      CurrConvSet
    }
    else {
      did -ra $dname 4 Only use numbers and dots (.) when you want to convert.
    }
  }
}

menu channel { 
  $iif(%xemenu == channel,Currency,$null) { currconv }
}

on *:DIALOG:CurrConv:SCLICK:12: { 
  if ($did(12).state == 1) { set %xemenu channel }
  else { unset %xemenu }
}

on *:DIALOG:CurrConv:SCLICK:6: { clipboard $did($dname,4) }
on *:DIALOG:CurrConv:CLOSE:0: { unset %xe.* | .remove $CurrConvTmp }
on *:DIALOG:CurrConv:EDIT:1: {
  if ($did($dname,1) == $null) {
    did -b $dname 7
  }
  elseif ($did($dname,1) != $null) {
    did -e $dname 7
  }
}

on *:sockopen:xe:{
  set %xe.get /ucc/convert.cgi?Amount= $+ %xe.amount $+ &From= $+ %xe.from $+ &To= $+ %xe.to
  sockwrite -n $sockname GET %xe.get HTTP/1.1
  sockwrite -n $sockname Host: www.xe.com
  sockwrite -n $sockname
}

on *:sockread:xe:{
  sockread %xe.temp
  tokenize 32 %xe.temp
  if ($CurrConvStrip(%xe.temp)) { var %xe.temp2 = $remove($CurrConvStrip(%xe.temp),$chr(46)) | $iif($gettok(%xe.temp2,1,32) isnum,write $CurrConvTmp $CurrConvStrip(%xe.temp),) | .timerXE 1 3 CurrConvPut }
}

;EOF
